

struct PEB
   InheritedAddressSpace           db  0
   ReadImageFileExecOptions        db  0
   BeingDebugged                   db  0
   BitField                        db  0
   Padding1                        dd  0 
   Mutant                          dq  0
   ImageBaseAddress                dq  0
   Ldr                             dq  0    ;  PEB_LDR_DATA
   ProcessParameters               dq  0    ;  RTL_USER_PROCESS_PARAMETERS
   SubSystemData                   dq  0
   ProcessHeap                     dq  0
   FastPebLock                     dq  0    ;  RTL_CRITICAL_SECTION
   AtlThunkSListPtr                dq  0
   IFEOKey                         dq  0
   CrossProcessFlags               dq  0
   KernelCallbackTable             dq  0
;   UserSharedInfoPtr               dq  0
   SystemReserved                  dd  0
   AtlThunkSListPtr32              dd  0
   ApiSetMap                       dq  0
   TlsExpansionCounter             dq  0
   TlsBitmap                       dq  0
   TlsBitmapBits                   dq  0
   ReadOnlySharedMemoryBase        dq  0
   HotpatchInformation             dq  0
   ReadOnlyStaticServerData        dq  0
   AnsiCodePageData                dq  0
   OemCodePageData                 dq  0
   UnicodeCaseTableData            dq  0
   NumberOfProcessors              dd  0
   NtGlobalFlag                    dd  0
   CriticalSectionTimeout          dq  0
   HeapSegmentReserve              dq  0
   HeapSegmentCommit               dq  0
   HeapDeCommitTotalFreeThreshold  dq  0
   HeapDeCommitFreeBlockThreshold  dq  0
   NumberOfHeaps                   dd  0
   MaximumNumberOfHeaps            dd  0
   ProcessHeaps                    dq  0
   GdiSharedHandleTable            dq  0
   ProcessStarterHelper            dq  0
   GdiDCAttributeList              dq  0
   LoaderLock                      dq  0    ;  RTL_CRITICAL_SECTION
   OSMajorVersion                  dd  0
   OSMinorVersion                  dd  0
   OSBuildNumber                   dw  0
   OSCSDVersion                    dw  0
   OSPlatformId                    dd  0
   ImageSubsystem                  dd  0
   ImageSubsystemMajorVersion      dd  0
   ImageSubsystemMinorVersion      dd  0
   Padding2                        dd  0
   ActiveProcessAffinityMask       dq  0
   GdiHandleBuffer                 dd  60 dup(0)
   PostProcessInitRoutine          dq  0
   TlsExpansionBitmap              dq  0
   TlsExpansionBitmapBits          dd  32 dup(0)
   SessionId                       dq  0
   AppCompatFlags                  dq  0
   AppCompatFlagsUser              dq  0
   pShimData                       dq  0
   AppCompatInfo                   dq  0
   Reserved                        dq  0    ;  UNICODE_STRING.Len
   CSDVersion                      dq  0    ;  UNICODE_STRING.Name
   ActivationContextData           dq  0    ;  ACTIVATION_CONTEXT_DATA
   ProcessAssemblyStorageMap       dq  0    ;  ASSEMBLY_STORAGE_MAP
   SystemActivationContextData     dq  0    ;  ACTIVATION_CONTEXT_DATA
   SystemAssemblyStorageMap        dq  0    ;  ASSEMBLY_STORAGE_MAP
   MinimumStackCommit              dq  0
   FlsCallback                     dq  0    ;  FLS_CALLBACK_INFO
   FlsListHead                     dq  0,0  ;  LIST_ENTRY
   FlsBitmap                       dq  0
   FlsBitmapBits                   dq  0,0
   FlsHighIndex                    dq  0
   WerRegistrationData             dq  0
   WerShipAssertPtr                dq  0
   pContextData                    dq  0
   pImageHeaderHash                dq  0
   TracingFlags                    dd  0
ends

struct STRING
   Length           dw  0
   MaximumLength    dw  0
   Padding          dd  0
   Buffer           dq  0 
ends
struct UNICODE_STRING
   Length           dw  0
   MaximumLength    dw  0
   Padding          dd  0
   Buffer           dq  0 
ends
struct RTL_DRIVE_LETTER_CURDIR
   Flags            dw  0
   Length           dw  0
   TimeStamp        dd  0
   DosPath          STRING
ends
struct CURDIR
   DosPath          UNICODE_STRING
   Handle           dq  0
ends 

struct RTL_USER_PROCESS_PARAMETERS
   MaximumLength       dd  0
   Length              dd  0
   Flags               dd  0
   DebugFlags          dd  0
   ConsoleHandle       dq  0     ;<-------- !
   ConsoleFlags        dd  0
   Padding1            dd  0
   StandardInput       dq  0
   StandardOutput      dq  0
   StandardError       dq  0
   CurrentDirectory    CURDIR
   DllPath             UNICODE_STRING
   ImagePathName       UNICODE_STRING
   CommandLine         UNICODE_STRING
   Environment         dq  0
   StartingX           dd  0
   StartingY           dd  0
   CountX              dd  0
   CountY              dd  0
   CountCharsX         dd  0
   CountCharsY         dd  0
   FillAttribute       dd  0
   WindowFlags         dd  0
   ShowWindowFlags     dd  0
   Padding2            dd  0
   WindowTitle         UNICODE_STRING
   DesktopInfo         UNICODE_STRING
   ShellInfo           UNICODE_STRING
   RuntimeData         UNICODE_STRING
ends

struct PEB_LDR_DATA
   Length                  dd  0
   Initialized             dd  0
   SsHandle                dq  0
   InLoadOrderModuleList   dq  0,0       ; \
   InMemoryOrderModuleList dq  0,0       ;  } LIST_ENTRY
   InInitOrderModuleList   dq  0,0       ; /
   EntryInProgress         dq  0
   ShutdownInProgress      dq  0
   ShutdownThreadId        dq  0
ends

struct LDR_DATA_TABLE_ENTRY              ;<--------- LIST_ENTRY   
   InLoadOrderLinks        dq  0,0       ; \
   InMemoryOrderLinks      dq  0,0       ;  } LIST_ENTRY
   InInitOrderLinks        dq  0,0       ; /
   DllBase                 dq  0
   EntryPoint              dq  0
   SizeOfImage             dd  0
   Padding1                dd  0
   FullDllName             UNICODE_STRING
   BaseDllName             UNICODE_STRING
   Flags                   dd  0
   LoadCount               dw  0
   TlsIndex                dw  0
   SectionPointer          dq  0
   CheckSum                dd  0
   Padding2                dd  0
   TimeDateStamp           dd  0
   Padding3                dd  0
   EntryPointActContext    dq  0
   PatchInformation        dq  0
   ForwarderLinks          dq  0,0       ; \
   ServiceTagLinks         dq  0,0       ;  } LIST_ENTRY
   StaticLinks             dq  0,0       ; /
   ContextInformation      dq  0
   OriginalBase            dq  0
   LoadTime                dq  0
ends

struct KSYSTEM_TIME
   LowPart      dd  0
   High1Time    dd  0
   High2Time    dd  0
ends

;// enum NT_PRODUCT_TYPE
;//-----------------------
NtProductWinNt      =  1
NtProductLanManNt   =  2
NtProductServer     =  3

struct KUSER_SHARED_DATA
   TickCountLowDeprecated      dd  0
   TickCountMultiplier         dd  0
   InterruptTime               KSYSTEM_TIME
   SystemTime                  KSYSTEM_TIME
   TimeZoneBias                KSYSTEM_TIME
   ImageNumberLow              dw  0
   ImageNumberHigh             dw  0
   NtSystemRoot                dw  260 dup(0)
   MaxStackTraceDepth          dd  0
   CryptoExponent              dd  0
   TimeZoneId                  dd  0
   LargePageMinimum            dd  0
   Reserved                    dd  7 dup(0)
   NtProductType               dd  0         ;<--- NT_PRODUCT_TYPE
   ProductTypeIsValid          dd  0
   NtMajorVersion              dd  0
   NtMinorVersion              dd  0
   ProcessorFeatures           db  64 dup(0)
   Reserved1                   dq  0
   TimeSlip                    dd  0
   AlternativeArchitecture     dd  0
   AltArchitecturePad          dd  0
   SystemExpirationDate        dq  0
   SuiteMask                   dd  0
   KdDebuggerEnabled           db  0
   NXSupportPolicy             db  0
   Reserved2                   dw  0
   ActiveConsoleId             dd  0
   DismountCount               dd  0
   ComPlusPackage              dd  0
   LastSysRITEventTickCount    dd  0
   NumberOfPhysicalPages       dd  0
   SafeBootMode                db  0
   TscQpcData                  db  0
   TscQpcPad                   dw  0
   SharedDataFlags             dd  0
   DataFlagsPad                dd  0
   TestRetInstruction          dq  0
   SystemCall                  dd  0
   SystemCallReturn            dd  0
   SystemCallPad               dq  0,0,0
   TickCount                   KSYSTEM_TIME
   TickCountPad                dd  0
   Cookie                      dd  0
   CookiePad                   dd  0
   ConsoleSessionForegroundPid dq  0
   Wow64SharedInfo             dd  16 dup(0)
   UserModeGlobalLogger        dw  16 dup(0)
   ImageFileExecutionOptions   dd  0
   LangGenerationCount         dd  0
   Reserved5                   dq  0
   InterruptTimeBias           dq  0
   TscQpcBias                  dq  0
   ActiveProcessorCount        dd  0
   ActiveGroupCount            dw  0
   Reserved4                   dw  0
   AitSamplingValue            dd  0
   AppCompatFlag               dd  0
ends
























